﻿-- LBP.lua


function deepcopy(t)
	if type(t) ~= 'table' then return t end
	local mt = getmetatable(t)
	local res = {}
	for k,v in pairs(t) do
		if type(v) == 'table' then
			v = deepcopy(v)
		end
		res[k] = v
	end
	setmetatable(res,mt)
	return res
end

-- Variablen
local NameOfProject = "Lazy Boss Preparation"										-- Name des Projekts
local EventFrame														-- Frame, das auf Events reagiert
local TimeSinceLastUpdate = 0.0
local UpdateFrequency = 1;
local LBPMainframe 												-- dummy fuer das Hauptframe
local LBPConfigframe 
local showmode = false;


if ( GetLocale() == "deDE" ) then
	L = LBP_Strings["deDE"]
	else
	L = LBP_Strings["enGB"]
end

LBP = {}


LBP_DB = {															-- default Konfiguration,
	-- wird während des Variabelnladens
	-- ueberschrieben
	
};


local debugging = false


function LBP.echo( self, msg )												-- Beginn echo
	-- Einfache Routine zur Ausgabe von Nachrichten
	if not msg then
		msg = "Error: nil"
	end
	DEFAULT_CHAT_FRAME:AddMessage("|cff00FFFF"..NameOfProject..":|r "..msg)
	
end	

-- Ende echo





function LBP.CreateCard( self, parent)
	
	local frame = LBP:CreateFrame("frame", "LBP_Templatecard"..time(), parent, nil, "TOP", parent, "BOTTOM", 0, 0, 270, 270)
	--frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	--	frame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	frame:SetBackdrop({bgFile = "Interface/BUTTONS/WHITE8X8", edgeFile = "Interface/LFGFrame/LFGBorder", edgeSize = 8, insets = { left = 2, right = 2, top = 2, bottom = 2 } });
	--frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/LFGFrame/LFGBorder", edgeSize = 8, insets = { left = 2, right = 2, top = 2, bottom = 2 } });
	
	--local notreadyframe = LBP:CreateFrame("frame", "LBP_Readyframe"..time(), frame, nil, "CENTER", frame, "BOTTOMRIGHT", -16, 16, 64, 64)
	--		notreadyframe:SetBackdrop({bgFile = "Interface/RAIDFRAME/ReadyCheck-NotReady"});
	
	local instanceID = nil
	local encounterID = nil
	local id = nil
	
	
	local isSet, shouldbe, a,b, prepared
	function frame:CheckTalents( self )
		prepared = true
		for a = 1,7 do
			for b = 0,2 do
				_, _, _, _, isSet = GetTalentInfo(a,b+1,GetActiveSpecGroup())
				shouldbe = tonumber(string.sub(LBP_DB[instanceID][encounterID][id]["Talents"],a,a));
				
				frame.Talents[(a-1)*3+b+1].texture:SetDesaturated(true);
				frame.Talents[(a-1)*3+b+1].texture:SetVertexColor(1,1,1,1);
				frame.Talents[(a-1)*3+b+1]:SetHeight(24)
				frame.Talents[(a-1)*3+b+1]:SetWidth(24)
				
				if b == shouldbe then
					frame.Talents[(a-1)*3+b+1].texture:SetDesaturated(false);
					frame.Talents[(a-1)*3+b+1].texture:SetVertexColor(1,0,0,1);
					frame.Talents[(a-1)*3+b+1]:SetHeight(32)
					frame.Talents[(a-1)*3+b+1]:SetWidth(32)
					
					if not isSet then
						prepared = false
					end
				end
				if isSet then
					frame.Talents[(a-1)*3+b+1].texture:SetDesaturated(false);
					frame.Talents[(a-1)*3+b+1].texture:SetVertexColor(1,1,1,1);
				end
			end
		end
		
		return prepared
	end
	
	
	
	
	
	local currentGlyphs, index,value,icon, glyph_id, a, b, drin
	local shouldbe = {}
	function frame:CheckGlyphs( self )
		
		currentGlyphs = LBP:GetGlyphTable()
		prepared = true;
		
		
		
		for a = 1,6 do
			shouldbe[a] = currentGlyphs[a][2]
		end
		
		
		for c = 1,2 do -- first major, than minor glyphs
			
			-- checks if the current glyph is in the list
			for a = c,6,2 do
				drin = false
				
				for icon, glyph_id in pairs(LBP_DB[instanceID][encounterID][id]["Glyphs"][tostring(3-c)]) do
					if icon == shouldbe[a] then
						
						drin = true
						break
					end
				end
				
				-- if not, goes through the list. if a glyph from the list is not set yet, and sets it
				
				if not drin then
					
					for icon, glyph_id in pairs(LBP_DB[instanceID][encounterID][id]["Glyphs"][tostring(3-c)]) do
						drin = false
						for b = c,6,2 do
							if icon == shouldbe[b] then
								drin = true
								break
							end
						end
						if not drin then
							shouldbe[a] = icon
							prepared = false
						end
					end
				end
			end
			
		end
		
		for c = 1,2 do
			for a = c,6,2 do
				--print(GetTime())
				if shouldbe[a] == currentGlyphs[a][2] then
					if frame.Glyph[a]:SetGlyph(shouldbe[a], true) then
						frame.Glyph[a]:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(frame.Glyph[a]); GameTooltip:SetGlyphByID(currentGlyphs[a][3]); GameTooltip:Show(); end)
						frame.Glyph[a]:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)
					end
					else
					if frame.Glyph[a]:SetGlyph(shouldbe[a], false) then
						frame.Glyph[a]:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(frame.Glyph[a]); GameTooltip:SetGlyphByID(LBP_DB[instanceID][encounterID][id]["Glyphs"][tostring(3-c)][shouldbe[a]]); GameTooltip:Show(); end)
						frame.Glyph[a]:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)
					end
				end
			end
		end
		
		
		return prepared
	end
	
	
	
	
	
	
	
	
	frame.SpecIcon_frame = LBP:CreateFrame("frame", "Templatecard_SpecIcon", frame, nil, "TOPLEFT", frame, "TOPLEFT", 10, -10, 32, 32)
	
	frame.SpecIcon = frame.SpecIcon_frame:CreateTexture("SpecIcon")
	frame.SpecIcon:SetTexture("Interface/ICONS/INV_MISC_QUESTIONMARK");
	frame.SpecIcon:SetAllPoints()
	
	frame.TemplateName = LBP:CreateFontString(frame, "textbox","ARTWORK", "GameFontNormalLarge", "TOPLEFT", frame.SpecIcon, "TOPRIGHT", 6, 0, 200, 18, "LEFT", "BOTTOM", 1, 1, 1, 1)
	frame.TemplateSpec = LBP:CreateFontString(frame, "textbox","ARTWORK", "GameFontNormal", "TOPLEFT", frame.TemplateName, "BOTTOMLEFT", 0, 0, 200, 14, "LEFT", "TOP", 1, 1, 1, 1)
	
	local editbutton = LBP.CreateCloseButton(self, frame, "Templatecard_editbutton", 24, "TOPRIGHT", frame, "TOPRIGHT", 0, 0)
	--editbutton:SetNormalTexture("Interface/BUTTONS/UI-Panel-BiggerButton-Up")
	editbutton:SetNormalTexture("Interface/GossipFrame/BinderGossipIcon")
	local NormalTexture = editbutton:GetNormalTexture()
	NormalTexture:SetTexCoord(0, 1, 0, 1)
	NormalTexture:ClearAllPoints()
	NormalTexture:SetPoint("TOPLEFT", editbutton, "TOPLEFT", 4, -5)
	NormalTexture:SetPoint("BOTTOMRIGHT", editbutton, "BOTTOMRIGHT", -4, 4)
	editbutton:SetPushedTexture("Interface/GossipFrame/BinderGossipIcon")
	
	local NormalTexture = editbutton:GetPushedTexture()
	NormalTexture:SetTexCoord(0, 1, 0, 1)
	NormalTexture:ClearAllPoints()
	NormalTexture:SetPoint("TOPLEFT", editbutton, "TOPLEFT", 4-1, -5-2)
	NormalTexture:SetPoint("BOTTOMRIGHT", editbutton, "BOTTOMRIGHT", -4-1, 4-2)		
	--editbutton:SetPushedTexture("Interface/BUTTONS/UI-Panel-BiggerButton-Down")
	
	editbutton:SetScript("OnClick", 
		function(self) 
			LBPConfigframe:SetTemplate(instanceID, encounterID, id)
			LBPConfigframe:Show()
			LBPConfigframe:Build()
			parent:Hide()
		end)
		
		
		
		frame.editbutton = editbutton
		
		frame.Talents = {};
		
		local classDisplayName, class, classID = UnitClass("player");
		local c
		for a=1,7 do
			for b = 1,3 do 
				
				c = (a-1)*3+b;
				local talentID, _, iconTexture = GetTalentInfo(a,b,GetActiveSpecGroup())
				
				local tmpframe = LBP:CreateFrame("frame", "LBPTalent"..c, frame, nil, "CENTER", frame, "TOPLEFT", (b-1)*32+26, -(a-1)*32-40-32, 32, 32)
				
				
				tmpframe.texture = tmpframe:CreateTexture("LBPTalent"..c)
				tmpframe.texture:SetTexture(iconTexture)
				tmpframe.texture:SetAllPoints()
				
				frame.Talents[c] = tmpframe;
				frame.Talents[c]:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(frame.Talents[a]); GameTooltip:SetTalent(talentID); GameTooltip:Show(); end)
				frame.Talents[c]:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)
				--frame.Talents[a]:SetScript("OnMouseUp", function() if PlayerTalentFrame and PlayerTalentFrame:IsVisible() then PlayerTalentFrame_Close() else ToggleTalentFrame() PlayerTalentFrame_Open() end end)
				-- frame.Talents[c]:SetScript("OnMouseUp", function() ToggleTalentFrame() PlayerTalentFrame_Open() end)
			end
		end
		
		--frame.prepared
		
		local glyphposition = {
			["x"] = {24+4, 0, -24-4, -20-4, 0, 20+4},
			["y"] = {2, 20, 2, -2, -26, -2},
			["point"] = {"BOTTOMLEFT", "BOTTOM", "BOTTOMRIGHT", "TOPRIGHT", "TOP", "TOPLEFT" },
			["length"] = {40,48,40,48,40,48},
		}
		
		
		frame.Glyph = {};
		
		for a=1,6 do
			local tmpframe = LBP:CreateFrame("frame", "LBPGlyph"..a, frame, nil, glyphposition["point"][a], frame, "TOPRIGHT", glyphposition["x"][a]-80, glyphposition["y"][a]-40-32+16-48-20, glyphposition["length"][a], glyphposition["length"][a])
			
			
			tmpframe.texture = tmpframe:CreateTexture("LBPGylph"..a)
			
			tmpframe.texture:SetAllPoints()
			tmpframe:SetBackdrop({
				bgFile = "Interface/ICONS/INV_MISC_QUESTIONMARK"
			})
			
			tmpframe.icon = "Interface/ICONS/INV_MISC_QUESTIONMARK"
			-- tmpframe:SetScript("OnMouseUp", function() ToggleTalentFrame(); OpenGlyphFrame() end)
			
			function tmpframe:SetGlyph(icon, tmp)
				
				if tmp then
					tmpframe.texture:SetVertexColor(1,1,1,1);
					else
					tmpframe.texture:SetVertexColor(1,0.2,0.2,1);
				end
				
				
				if tmpframe.texture:GetTexture() == icon then
					return false
					else
					tmpframe.texture:SetTexture(icon)
					return true
				end
				
				
			end
			
			
			frame.Glyph[a] = tmpframe;
		end
		
		
		
		local macro_iconTexture
		
		
		frame.macroframe = {};
		
		for a=1,4 do
			frame.macroframe[a] = LBP:CreateFrame("frame", "Macroframe"..a, frame, nil, "TOPRIGHT", frame, "TOPRIGHT", -10+(a-4)*36, -232+16, 32, 32);
			frame.macroframe[a]:SetBackdrop({bgFile = "Interface/ICONS/INV_MISC_QUESTIONMARK" });
			frame.macroframe[a].bgFile = "Interface/ICONS/INV_MISC_QUESTIONMARK";
			frame.macroframe[a]:SetScript("OnLeave", function(self, event, ...) GameTooltip:Hide(); end)		
		end
		
		
		
		
		
		local readyframe = LBP:CreateFrame("frame", "LBP_Readyframe"..time(), frame, nil, "CENTER", frame, "BOTTOMRIGHT", -16, 16, 64, 64)
		readyframe:SetBackdrop({bgFile = "Interface/RAIDFRAME/ReadyCheck-Ready"});
		
		
		
		local body
		
		function frame:Update(self, arg1, arg2, arg3)
			
			instanceID = arg1
			encounterID = arg2
			id = arg3
			
			
			frame.prepared = true;
			
			if not InCombatLockdown() then
				
				specid, spec, description, icon, background, role = GetSpecializationInfoByID(LBP_DB[instanceID][encounterID][id]["Spec"]);
				
				frame.SpecIcon:SetTexture(icon)
				
				
				specid = GetSpecializationInfo(GetSpecialization());
				
				if LBP_DB[instanceID][encounterID][id]["Spec"] == specid then
					frame.TemplateSpec:SetText("|cff00FF00"..spec.."|r");
					frame.SpecIcon:SetDesaturated(false);
					frame.SpecIcon:SetVertexColor(1.0, 1.0, 1.0)
					else
					frame.TemplateSpec:SetText("|cffFF0000"..spec.."|r");
					frame.SpecIcon:SetDesaturated(true);
					frame.SpecIcon:SetVertexColor(1.0, 0.0, 0.0)
					frame.prepared = false;
				end
				
				if not LBP_DB[instanceID][encounterID][id]["Name"] then
					LBP_DB[instanceID][encounterID][id]["Name"] = "noname"
				end
				frame.TemplateName:SetText(LBP_DB[instanceID][encounterID][id]["Name"].."\n");
				
				if not frame:CheckTalents( self, arg1, arg2, arg3 ) then
					frame.prepared = false;
				end
				
				if not frame:CheckGlyphs( self, arg1, arg2, arg3 ) then
					frame.prepared = false;
				end
				
				
				for a=1,4 do
					if not LBP_DB[instanceID][encounterID][id]["Macro"..a] then LBP_DB[instanceID][encounterID][id]["Macro"..a] = "/script print(\"LBP: Macro #"..a.."\")"; end
					
					body = GetMacroBody("LBP Macro "..a)
					
					if body ~= LBP_DB[instanceID][encounterID][id]["Macro"..a] then	
						EditMacro(GetMacroIndexByName("LBP Macro "..a),"LBP Macro "..a,nil, LBP_DB[instanceID][encounterID][id]["Macro"..a]) 
						frame.macroframe[a]:SetScript("OnEnter", function(self, event, ...) GameTooltip:SetOwner(frame.macroframe[a]); GameTooltip:SetText(LBP_DB[instanceID][encounterID][id]["Macro"..a],nil, nil, nil, nil, true); GameTooltip:Show(); end)
					end
					
					_, macro_iconTexture = GetMacroInfo("LBP Macro "..a);
					
					
					if macro_iconTexture ~= frame.macroframe[a].bgFile then
						frame.macroframe[a]:SetBackdrop({bgFile = macro_iconTexture });
						frame.macroframe[a].bgFile = macro_iconTexture;
					end
				end
				
				
				
				frame:SetHeight(260+32)
				
				
				
				if frame.prepared then
					frame:SetBackdropColor(0, 0, 0 , .85)
					--notreadyframe:Hide()
					readyframe:Show()
					else
					frame:SetBackdropColor(.3, 0, 0 , .85)
					readyframe:Hide()
					--notreadyframe:Show()
				end
				
			end
			
			return frame.prepared
		end
		
		
		
		frame:Hide()
		return frame
end



function LBP.CreateWindow(self)
	local frame = LBP:CreateFrame("frame", "LBPMainFrame", UIParent, nil, "TOP", UIParent, "CENTER", 0, 350, 220, 50)
	--frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	
	--frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/Tooltips/UI-Tooltip-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	--frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/BUTTONS/UI-SliderBar-Border", edgeSize = 4, insets = { left = 0, right = 0, top = 3, bottom = 2 } });
	frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/LFGFrame/LFGBorder",tile = false, tileSize = 16, edgeSize = 8, insets = { left = 2, right = 2, top = 2, bottom = 2 } });
	--frame:Show()
	
	frame.button = LBP.CreateCloseButton(self, frame, "Window_CloseButton", 24, "TOPRIGHT", frame, "TOPRIGHT", -1, -1)
	frame.button:SetScript("OnClick", function(self) frame:Hide() frame:SetAlpha(-2) end)
	
	
	local alpha = 1
	
	tinsert(UISpecialFrames,"LBPMainFrame");
	
	local textbox = LBP:CreateFontString(frame, "textbox","ARTWORK", "GameFontNormal", "CENTER", frame, "CENTER", 0, 0, 220-24-24, 14*3, "CENTER", "MIDDLE", 1, 1, 1, 1)
	textbox:SetText("instanceID")
	
	
	frame.instanceID = nil
	frame.encounterID = nil
	
	
	function frame:CreateTab( self, parent, instanceID, encouterID, id)
		local frame = LBP:CreateFrame("frame", "LBP_Templatecard"..time(), parent, nil, "CENTER", parent, "CENTER", 0, 0, 220, 52)
		frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/LFGFrame/LFGBorder",tile = false, tileSize = 16, edgeSize = 8, insets = { left = 2, right = 2, top = 2, bottom = 2 } });
		
		local specidid, name, description, icon, background, role, class = GetSpecializationInfoByID(LBP_DB[instanceID][encouterID][id]["Spec"])
		
		frame.SpecIcon = frame:CreateTexture("Texture")
		frame.SpecIcon:SetTexture(icon)
		frame.SpecIcon:SetDesaturated(true);
		frame.SpecIcon:SetPoint("TOPLEFT", frame, "TOPLEFT", 10, -10)
		frame.SpecIcon:SetPoint("BOTTOMRIGHT", frame, "TOPLEFT", 10+32, -10-32)
		
		frame.TemplateName = LBP:CreateFontString(frame, "textbox","ARTWORK", "GameFontNormal", "LEFT", frame.SpecIcon, "RIGHT", 6, 0, 200, 18, "LEFT", "BOTTOM", 1, 1, 1, 1)
		--frame.TemplateSpec = LBP:CreateFontString(frame, "textbox","ARTWORK", "GameFontNormal", "TOPLEFT", frame.TemplateName, "BOTTOMLEFT", 0, 0, 200, 14, "LEFT", "TOP", 1, 1, 1, 1)
		
		frame:SetScript("OnMouseUp", function(self)
			for index,value in pairs(LBP_DB[instanceID][encouterID]) do
				value["active"] = false
			end
			
			LBP_DB[instanceID][encouterID][id]["active"] = true;
			
			
			LBPMainFrame:Check()
		end)
		
		
		
		local spec, icon
		
		function frame:Update()
			_, spec, _, icon = GetSpecializationInfoByID(LBP_DB[instanceID][encouterID][id]["Spec"]);
			frame.SpecIcon:SetTexture(icon)
			frame.TemplateName:SetText(LBP_DB[instanceID][encouterID][id]["Name"].."\n");
		end
		
		frame:Hide()
		
		return frame
	end
	
	
	
	frame.anker = LBP:CreateFrame("frame", "LBPMainFrameAnker", frame, nil, "TOP", frame, "BOTTOM", 0, 0, 1, 1)
	local tmpanker = frame.anker;
	--local tmp = LBP:CreateFrame("frame", "tmp", frame, nil, "TOP", frame, "BOTTOM", 0, 0, 1, 1)
	
	local n
	
	frame.createtemplate = LBP:CreateFrame("frame", "LBPMainFrame", frame, nil, "TOP", frame, "BOTTOM", 0, 0, 270, 130)
	frame.createtemplate:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/LFGFrame/LFGBorder",tile = false, tileSize = 16, edgeSize = 8, insets = { left = 2, right = 2, top = 2, bottom = 2 } });
	
	local textbox2 = LBP:CreateFontString(frame.createtemplate, "textbox","ARTWORK", "GameFontNormal", "TOP", frame.createtemplate, "TOP", 0, -15, 270-15-15, 130-15-15, "LEFT", "TOP", 1, 1, 1, 1)
	textbox2:SetText(L["notemplate"])
	
	
	
	
	
	
	
	
	local createtemplatebutton = LBP:CreateFrame("BUTTON", "Button_CreateCard", frame.createtemplate, "UIPanelButtonTemplate", "BOTTOM", frame.createtemplate, "BOTTOM", 0, 15, 80, 30)
	createtemplatebutton:SetText(L["create"])
	createtemplatebutton:Show()	
	createtemplatebutton:SetScript("OnMouseUp", function(self) 
		
		local specid, specname, description, icon, background, role = GetSpecializationInfo(GetSpecialization());
		card = {};
		card["Name"] = EJ_GetEncounterInfo(frame.encounterID);
		card["active"] = true;
		card["Talents"] = LBP:GetTalentString();
		card["Spec"] = specid;
		card["Glyphs"] = {
			["1"] = {},
			["2"] = {}
		};
		for index,value in pairs(LBP:GetGlyphTable()) do
			if value[2] and value[3] then
				card["Glyphs"][tostring(value[1])][value[2]] = value[3];
			end
		end
		card["Macro1"] = "/script print(\"LBP Macro #1\")";
		card["Macro2"] = "/script print(\"LBP Macro #2\")";
		card["Macro3"] = "/script print(\"LBP Macro #3\")";
		card["Macro4"] = "/script print(\"LBP Macro #4\")";
		
		local id = time()
		
		if not LBP_DB[frame.instanceID] then LBP_DB[frame.instanceID] = {} end
		if not LBP_DB[frame.instanceID][frame.encounterID] then 
			LBP_DB[frame.instanceID][frame.encounterID] = {} 
		end
		
		
		
		
		
		
		while LBP_DB[frame.instanceID][frame.encounterID][id] do
			id = id-1;
		end
		
		LBP_DB[frame.instanceID][frame.encounterID][id] = card;
		
		LBPConfigframe:SetTemplate(frame.instanceID, frame.encounterID, id)
		LBPConfigframe:Show()
		LBPConfigframe:Build()
		
		frame:Hide()
		
	end)
	
	
	
	
	
	
	
	local ControlActive_active = false
	local i, e, id
	function frame:ControlActive()
		for i in pairs(LBP_DB) do
			for e in pairs(LBP_DB[i]) do
				ControlActive_active = false
				for id, value in pairs(LBP_DB[i][e]) do
					if ControlActive_active then
						value["active"] = false
					end
					if value["active"] == true then
						ControlActive_active = true
					end
				end
				if not ControlActive_active and id then
					LBP_DB[i][e][id]["active"] = true
				end
			end
		end
	end
	
	
	
	
	
	local prepared
	
	frame.template = LBP.CreateCard( self, frame )
	frame.template:SetPoint("TOP", frame, "BOTTOM", 0, 6)
	frame.template:Show()
	
	
	local tabs = {}
	local index = 0
	
	function frame:Check()
	
	
		if alpha == -2 then
			frame:Hide()
			return
		end
		
		if frame.encounterID and not LBP_DB[frame.instanceID] then
			textbox:SetText(EJ_GetInstanceInfo(frame.instanceID) .."\n".. EJ_GetEncounterInfo(frame.encounterID))
			frame.createtemplate:Show()
			frame.template:Hide()
			frame:Show()
			return
		end
		if frame.encounterID and not LBP_DB[frame.instanceID][frame.encounterID] then
			textbox:SetText(EJ_GetInstanceInfo(frame.instanceID) .."\n".. EJ_GetEncounterInfo(frame.encounterID))
			frame.createtemplate:Show()
			frame.template:Hide()
			frame:Show()
			return
		end
		
		
		-- hide all tabs
		for id in pairs(tabs) do
			tabs[id]:Hide()
		end
		
		
		
		frame:ControlActive()
		
		prepared = true
		
		frame.createtemplate:Hide()	
		if frame.encounterID then
			if LBPConfigframe:IsVisible() then
				LBPConfigframe:Hide()
			end
			
			frame:Show()
			frame.template:Show()
			textbox:SetText(EJ_GetInstanceInfo(frame.instanceID) .."\n".. EJ_GetEncounterInfo(frame.encounterID))
			index = 0
			
			for id, value in pairs(LBP_DB[frame.instanceID][frame.encounterID]) do
				if not tabs[id] then
					tabs[id] = frame:CreateTab(self, frame, frame.instanceID, frame.encounterID, id)
				end
				
				if LBP_DB[frame.instanceID][frame.encounterID][id]["active"] then 
					prepared = frame.template:Update(self, frame.instanceID, frame.encounterID, id)
					else
					tabs[id]:SetPoint("TOP", frame.template, "BOTTOM", 0, 6 - index*48)
					--tabs[id]:SetFrameLevel(frame:GetFrameLevel()-1-index)
					tabs[id]:Update()
					tabs[id]:Show()
					index = index +1
				end
			end
			
			else
			if not LBPConfigframe:IsVisible() then
				LBPConfigframe:Show()
				LBPConfigframe:Build()
			end
		end
	end
	
	
	
	
	
	
	
	
	
	--[[
		local oldShow = frame.Show;
		
		frame.Show = function(...)
		frame:Check()
		oldShow(...)
		end
	--]]
	
	
	-- Fade out
	--[[	
		frame:SetScript("OnUpdate", function(self)
		if time()-TimeSinceLastUpdate > 0 then
		if alpha == -2 then
		frame:Hide()
		return
		end
		print(instanceID)
		print(encounterID)
		for index in pairs(LBP_DB[instanceID][encounterID]) do
		if LBP_DB[instanceID][encounterID][index]["active"] then
		template:Update()
		
		if alpha < 0 then
		frame:Hide()
		return
		end
		
		if alpha <= 1 then
		if template.prepared then
		alpha = alpha - 0.001
		alpha = alpha - ((1-alpha)^3)/3
		else
		alpha = 1
		end	
		end
		frame:SetAlpha(alpha)	
		else
		alpha = 2
		frame.tabs[index]:Update()
		end
		end
		
		
		if alpha < 0 then
		--alpha = 1.1
		frame:Hide()
		elseif alpha >= 1 then
		TimeSinceLastUpdate = time()
		end
		end
		
		
		end)
		
		
		
	--]]	
	
	
	
	local oldShow = frame.Show;
	
	frame.Show = function(...)
		--frame:Check()
		TimeSinceLastUpdate = 0;
		oldShow(...)
	end
	
	local oldSetAlpha = frame.SetAlpha;
	
	frame.SetAlpha = function(self, a, ...)
		alpha = a;
		oldSetAlpha(self, a, ...)
	end
	
	
	
	
	
	
	
	
	
	frame:Hide()
	return frame
end


function LBP.GetTalentString(self)
	s = "";
	local c;
	for b = 1,7 do
		c = 3;
		for a = 1,3 do
			local name, iconTexture, tier, column, rank, maxRank, isExceptional, meetsPrereq, previewRank, meetsPreviewPrereq = GetTalentInfo(b,a,GetActiveSpecGroup())
			if rank then c = a-1; end
		end
		s = s..c;
	end
	return s
end



local glyphType, icon
local icon2, castSpell
local a,b
local s = {};

function LBP.GetGlyphTable(self)
	if not IsGlyphFlagSet(1) then ToggleGlyphFilter(1) end
	if not IsGlyphFlagSet(2) then ToggleGlyphFilter(2) end
	
	
	for b = 1,6 do
		if not s[b] then s[b] = {} end
		_, glyphType, _, _, icon = GetGlyphSocketInfo(b)
		
		for a=1,GetNumGlyphs() do 
			_, _, _, icon2, castSpell = GetGlyphInfo(a)
			if icon2 == icon then 
				s[b][1] = glyphType
				s[b][2] = icon
				s[b][3] = castSpell
				break 
			end
		end
	end
	return s
end





function LBP.OnEvent( self, event, name, ...)
	--LBP.GetMapDimension()
	
	if event=="UPDATE_MACROS" then
		if not InCombatLockdown() then
			local numglobal,numperchar = GetNumMacros();
			
			if numglobal > 32 then
				LBP:echo("Not enough space to create the macros. LBP needs four free macro slots")
				EventFrame:UnregisterAllEvents();				
				else
				if not GetMacroInfo("LBP Macro 1") then
					CreateMacro("LBP Macro 1", "INV_MISC_QUESTIONMARK", "/script print(\"LBP: Macro #1\")", nil);
				end
				if not GetMacroInfo("LBP Macro 2") then
					CreateMacro("LBP Macro 2", "INV_MISC_QUESTIONMARK", "/script print(\"LBP: Macro #2\")", nil);
				end
				if not GetMacroInfo("LBP Macro 3") then
					CreateMacro("LBP Macro 3", "INV_MISC_QUESTIONMARK", "/script print(\"LBP: Macro #3\")", nil);
				end
				if not GetMacroInfo("LBP Macro 4") then
					CreateMacro("LBP Macro 4", "INV_MISC_QUESTIONMARK", "/script print(\"LBP: Macro #4\")", nil);
				end
			end
		end
	end
	if event=="VARIABLES_LOADED" then
		
		EventFrame:SetScript("OnUpdate", 
			function(self, event, ... ) 
				
				local _, _, iconTexture = GetTalentInfo(7,3,1) 
				
				EJ_SelectTier(EJ_GetNumTiers())
				local instanceID = EJ_GetInstanceByIndex(1, true) 
				
				local name
				if instanceID then
					EJ_SelectInstance(instanceID)
					name = EJ_GetEncounterInfoByIndex(1, instanceID)
				end
				
				
				--[[				
					local index = 1 
					while EJ_GetInstanceByIndex(index, true) do
					local instanceID, name = EJ_GetInstanceByIndex(index, true) 
					EJ_SelectInstance(instanceID)
					if not EJ_GetEncounterInfoByIndex(1, instanceID) then
					a = false
					end
					index = index+1
					end
				--]]
				
				
				if iconTexture and name then 
					EventFrame:SetScript("OnUpdate", nil)
					
					
					LBPMainframe = LBP:CreateWindow();
					
					LBPConfigframe = LBP:CreateConfig(); 
					local readycheck = LBP:ReadyCheck();
					
					LBP.Mainframe = LBPMainframe;
					LBP.Configframe = LBPConfigframe;
					
					
					LBPMainframe:Hide()
					LBPConfigframe:Hide()
					
					
					
					-- autostart
					
					--LBPConfigframe:SetTemplate("Schrein der Zwei Monde", "Halle des Halbmonds", 1399132532)
					
					--LBPConfigframe:Show()
					--LBPConfigframe:Build()				
					
					
					
					
					
					--- DB Umwandlung
					
					
					-- LBPMainFrame.testtitel = LBP:CreateFrame("frame", "LBPMainFrame", UIParent, nil, "TOP", UIParent, "CENTER", 0, 250, 300, 100)
					-- LBPMainFrame.testtitel:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/LFGFrame/LFGBorder",tile = false, tileSize = 16, edgeSize = 8, insets = { left = 2, right = 2, top = 2, bottom = 2 } });
					
					-- LBPMainFrame.testtitel.button = LBP.CreateCloseButton(self, LBPMainFrame.testtitel, "Window_CloseButton", 24, "TOPRIGHT", LBPMainFrame.testtitel, "TOPRIGHT", -1, -1)
					-- LBPMainFrame.testtitel.button:SetScript("OnClick", function(self) LBPMainFrame.testtitel:Hide() LBPMainFrame.test:Hide() end)
					
					
					-- LBPMainFrame.testtitel.textbox = LBP:CreateFontString(LBPMainFrame.testtitel, "textbox","ARTWORK", "GameFontNormal", "CENTER", LBPMainFrame.testtitel, "CENTER", 0, 0, 300-24-24, 80, "CENTER", "MIDDLE", 1, 1, 1, 1)
					
					-- if ( GetLocale() == "deDE" ) then
					-- LBPMainFrame.testtitel.textbox:SetText("Aufgrund einer Umstellung der Datenbank müssen alle Vorlagen neu zugeordnet werden.\n\nZu welchem Bosskampf gehört diese Vorlage?")
					-- else
					-- LBPMainFrame.testtitel.textbox:SetText("Due to a change of the database, all templates have to be reassigned.\n\nTo which encounter does this card belong?")
					-- end
					
					
					
					
					-- LBPMainFrame.test = LBP:CreateCard( self, LBPMainFrame.testtitel, asdzone, asdsubzone, asdid )
					-- LBPMainFrame.test:SetPoint("TOP",LBPMainFrame.testtitel,"BOTTOM");
					-- LBPMainFrame.test:SetScale(UIParent:GetScale())
					-- LBP.updatedb()
					
					-- if  not LBPMainFrame.asdid then
					-- LBPMainFrame.testtitel:Hide() LBPMainFrame.test:Hide()
					-- end
					
					
					
					-- LBPMainFrame.createlist = LBP:CreateFrame("frame", "LBPConfigFrame", LBPMainFrame.test, nil, "TOPLEFT", LBPMainFrame.test, "TOPRIGHT", 0, 0, 200, 200)
					-- LBPMainFrame.createlist:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
					-- LBPMainFrame.createlist:Show()
					
					-- LBPMainFrame.createlist:SetFrameStrata("TOOLTIP")
					
					
					-- LBPMainFrame.createlist.DB = {}
					
					-- ToggleEncounterJournal()
					-- ToggleEncounterJournal()
					
					
					-- for a = EJ_GetNumTiers(),4,-1 do
					-- EJ_SelectTier(a)
					
					-- local name = EJ_GetTierInfo(a)
					
					-- LBPMainFrame.createlist.DB[a] = {}
					-- LBPMainFrame.createlist.DB[a]["Name"] = name;
					
					
					
					-- local index = 1 
					-- while EJ_GetInstanceByIndex(index, true) do
					-- local instanceID, name = EJ_GetInstanceByIndex(index, true) 
					-- EJ_SelectInstance(instanceID)
					-- LBPMainFrame.createlist.DB[a][instanceID] = {}
					-- LBPMainFrame.createlist.DB[a][instanceID]["Name"] = name
					
					
					-- local index2 = 1 
					-- while EJ_GetEncounterInfoByIndex(index2, instanceID) do 
					-- local name = EJ_GetEncounterInfoByIndex(index2, instanceID)
					
					-- index2 = index2+1
					-- LBPMainFrame.createlist.DB[a][instanceID][index2] = name
					-- end
					
					-- index = index+1
					-- end
					-- end	
					
					
					-- function LBPMainFrame.createlist.tierlist( self )
					
					-- local kids = { LBPMainFrame.createlist:GetChildren() };
					-- for _, child in ipairs(kids) do
					-- child:Hide()
					-- end
					
					-- LBPMainFrame.createlist:SetHeight(20)
					
					-- local tmpframe= LBP:CreateFrame("frame", "LBPConfigFrame", LBPMainFrame.createlist, nil, "TOPLEFT", LBPMainFrame.createlist, "TOPLEFT", 10, -10, 1, 1)
					
					
					
					-- if ( GetLocale() == "deDE" ) then
					-- jrmve = "Entfernen"
					-- else
					-- jrmve = "Remove this"
					-- end
					
					-- for a = EJ_GetNumTiers(),4,-1 do
					-- tmpframe = LBP:CreateFrame("frame", "test", LBPMainFrame.createlist, nil, "TOPLEFT", tmpframe, "BOTTOMLEFT", 0, 0, 180, 20)
					-- tmpframe.text = LBP:CreateFontString(tmpframe, "textbox","ARTWORK", "GameFontNormal", "TOPLEFT", tmpframe, "TOPLEFT", 0, 0, 180, 20, "LEFT","CENTER",1,1,1,1)
					-- tmpframe.text:SetText(LBPMainFrame.createlist.DB[a]["Name"])
					-- tmpframe:SetScript("OnEnter", function(self) self.text:SetText("|c00FFD100"..LBPMainFrame.createlist.DB[a]["Name"].."|r") end)
					-- tmpframe:SetScript("OnLeave", function(self) self.text:SetText("|cFFFFFFFF"..LBPMainFrame.createlist.DB[a]["Name"].."|r") end)
					-- tmpframe:SetScript("OnMouseUp", function(self) LBPMainFrame.createlist.raidlist(self,  a) end)
					
					-- LBPMainFrame.createlist:SetHeight(LBPMainFrame.createlist:GetHeight()+20)
					-- end
					
					-- tmpframe = LBP:CreateFrame("frame", "test", LBPMainFrame.createlist, nil, "TOPLEFT", tmpframe, "BOTTOMLEFT", 0, 0, 180, 20)
					-- tmpframe.text = LBP:CreateFontString(tmpframe, "textbox","ARTWORK", "GameFontNormal", "TOPLEFT", tmpframe, "TOPLEFT", 0, 0, 180, 20, "LEFT","CENTER",1,1,1,1)
					
					
					-- tmpframe = LBP:CreateFrame("frame", "test", LBPMainFrame.createlist, nil, "TOPLEFT", tmpframe, "BOTTOMLEFT", 0, 0, 180, 20)
					-- tmpframe.text = LBP:CreateFontString(tmpframe, "textbox","ARTWORK", "GameFontNormal", "TOPLEFT", tmpframe, "TOPLEFT", 0, 0, 180, 20, "LEFT","CENTER",1,1,1,1)
					-- tmpframe.text:SetText(jrmve)
					-- tmpframe:SetScript("OnEnter", function(self) self.text:SetText("|c00FFD100"..jrmve.."|r") end)
					-- tmpframe:SetScript("OnLeave", function(self) self.text:SetText("|cFFFFFFFF"..jrmve.."|r") end)
					-- tmpframe:SetScript("OnMouseUp", function(self) LBP_DB[LBPMainFrame.asdzone][LBPMainFrame.asdsubzone][LBPMainFrame.asdid] = nil	LBP.updatedb() end)					
					-- LBPMainFrame.createlist:SetHeight(LBPMainFrame.createlist:GetHeight()+40)
					-- end
					
					
					-- function LBPMainFrame.createlist.raidlist( self, number )
					
					-- local kids = { LBPMainFrame.createlist:GetChildren() };
					-- for _, child in ipairs(kids) do
					-- child:Hide()
					-- end
					
					-- LBPMainFrame.createlist:SetHeight(20)
					
					-- local tmpframe= LBP:CreateFrame("frame", "LBPConfigFrame", LBPMainFrame.createlist, nil, "TOPLEFT", LBPMainFrame.createlist, "TOPLEFT", 10, -10, 1, 1)
					
					
					-- for b=1000,1,-1 do
					-- if LBPMainFrame.createlist.DB[number][b] then
					-- tmpframe = LBP:CreateFrame("frame", "test", LBPMainFrame.createlist, nil, "TOPLEFT", tmpframe, "BOTTOMLEFT", 0, 0, 180, 20)
					-- tmpframe.text = LBP:CreateFontString(tmpframe, "textbox","ARTWORK", "GameFontNormal", "TOPLEFT", tmpframe, "TOPLEFT", 0, 0, 180, 20, "LEFT","CENTER",1,1,1,1)
					-- tmpframe.text:SetText(LBPMainFrame.createlist.DB[number][b]["Name"])
					-- tmpframe:SetScript("OnEnter", function(self) self.text:SetText("|c00FFD100"..LBPMainFrame.createlist.DB[number][b]["Name"].."|r") end)
					-- tmpframe:SetScript("OnLeave", function(self) self.text:SetText("|cFFFFFFFF"..LBPMainFrame.createlist.DB[number][b]["Name"].."|r") end)
					-- tmpframe:SetScript("OnMouseUp", function(self) LBPMainFrame.createlist.encounterlist(self, b) end)
					
					-- LBPMainFrame.createlist:SetHeight(LBPMainFrame.createlist:GetHeight()+20)
					-- end	
					-- end		
					
					-- tmpframe = LBP:CreateFrame("frame", "test", LBPMainFrame.createlist, nil, "TOPLEFT", tmpframe, "BOTTOMLEFT", 0, 0, 180, 20)
					-- tmpframe.text = LBP:CreateFontString(tmpframe, "textbox","ARTWORK", "GameFontNormal", "TOPLEFT", tmpframe, "TOPLEFT", 0, 0, 180, 20, "LEFT","CENTER",1,1,1,1)
					-- tmpframe.text:SetText("<")
					-- tmpframe:SetScript("OnEnter", function(self) self.text:SetText("|c00FFD100".."<".."|r") end)
					-- tmpframe:SetScript("OnLeave", function(self) self.text:SetText("|cFFFFFFFF".."<".."|r") end)
					-- tmpframe:SetScript("OnMouseUp", function(self) LBPMainFrame.createlist.tierlist(self) end)
					
					-- LBPMainFrame.createlist:SetHeight(LBPMainFrame.createlist:GetHeight()+20)
					
					
					-- end
					
					-- function LBPMainFrame.createlist.encounterlist( self, instanceID )
					
					-- local kids = { LBPMainFrame.createlist:GetChildren() };
					-- for _, child in ipairs(kids) do
					-- child:Hide()
					-- end
					
					-- LBPMainFrame.createlist:SetHeight(20)
					
					-- local tmpframe= LBP:CreateFrame("frame", "LBPConfigFrame", LBPMainFrame.createlist, nil, "TOPLEFT", LBPMainFrame.createlist, "TOPLEFT", 10, -10, 1, 1)
					
					-- local index = 1 
					
					
					-- while EJ_GetEncounterInfoByIndex(index, instanceID) do 
					-- local name, _, encounterID = EJ_GetEncounterInfoByIndex(index, instanceID)
					
					-- tmpframe = LBP:CreateFrame("frame", "test", LBPMainFrame.createlist, nil, "TOPLEFT", tmpframe, "BOTTOMLEFT", 0, 0, 180, 20)
					-- tmpframe.text = LBP:CreateFontString(tmpframe, "textbox","ARTWORK", "GameFontNormal", "TOPLEFT", tmpframe, "TOPLEFT", 0, 0, 180, 20, "LEFT","CENTER",1,1,1,1)
					-- tmpframe.text:SetText(name)
					-- tmpframe:SetScript("OnEnter", function(self) self.text:SetText("|c00FFD100"..name.."|r") end)
					-- tmpframe:SetScript("OnLeave", function(self) self.text:SetText("|cFFFFFFFF"..name.."|r") end)
					-- tmpframe:SetScript("OnMouseUp", function(self) 
					
					
					-- if not LBP_DB[instanceID] then
					-- LBP_DB[instanceID] = {}
					-- end
					-- if not LBP_DB[instanceID][encounterID] then
					-- LBP_DB[instanceID][encounterID] = {}
					-- end
					
					-- LBP_DB[instanceID][encounterID][LBPMainFrame.asdid] = deepcopy(LBP_DB[LBPMainFrame.asdzone][LBPMainFrame.asdsubzone][LBPMainFrame.asdid])
					
					-- LBP_DB[LBPMainFrame.asdzone][LBPMainFrame.asdsubzone][LBPMainFrame.asdid] = nil
					
					-- LBPMainFrame.createlist:tierlist()
					-- LBP.updatedb()
					
					-- end)						
					
					-- LBPMainFrame.createlist:SetHeight(LBPMainFrame.createlist:GetHeight()+20)
					-- index = index+1
					-- end
					
					-- tmpframe = LBP:CreateFrame("frame", "test", LBPMainFrame.createlist, nil, "TOPLEFT", tmpframe, "BOTTOMLEFT", 0, 0, 180, 20)
					-- tmpframe.text = LBP:CreateFontString(tmpframe, "textbox","ARTWORK", "GameFontNormal", "TOPLEFT", tmpframe, "TOPLEFT", 0, 0, 180, 20, "LEFT","CENTER",1,1,1,1)
					-- tmpframe.text:SetText("<")
					-- tmpframe:SetScript("OnEnter", function(self) self.text:SetText("|c00FFD100".."<".."|r") end)
					-- tmpframe:SetScript("OnLeave", function(self) self.text:SetText("|cFFFFFFFF".."<".."|r") end)
					-- tmpframe:SetScript("OnMouseUp", function(self) LBPMainFrame.createlist.tierlist(self) end)
					
					-- LBPMainFrame.createlist:SetHeight(LBPMainFrame.createlist:GetHeight()+20)
					
					
					-- end						
					
					
					
					-- LBPMainFrame.createlist:tierlist( self )					
					
					
					
					
				end 
			end
		)
		
		
		
		-- Macros
		
		
		--		LBPOnUpdateframe = LBP:CreateFrame("frame", "LBPOnUpdateFrame", UIParent, nil, "TOPLEFT", UIParent, "TOPLEFT", 0, 0, 10, 10)
		--LBPOnUpdateframe:SetScript("OnUpdate", function(self, event, ... ) LBP:OnUpdate(event, ...) end)
		
		
	end	
	
	
end		

function LBP.updatedb()
	
	for zone in pairs(LBP_DB) do
		if next(LBP_DB[zone]) == nil then
			LBP_DB[zone] = nil
			else
			for subzone in pairs(LBP_DB[zone]) do
				if next(LBP_DB[zone][subzone]) == nil then
					LBP_DB[zone][subzone] = nil
				end
			end
		end
	end
	
	
	LBPMainFrame.asdzone = nil
	LBPMainFrame.asdsubzone = nil
	LBPMainFrame.asdid = nil
	
	for zone in pairs(LBP_DB) do
		if not tonumber(zone) then
			for subzone in pairs(LBP_DB[zone]) do
				if not tonumber(subzone) then
					for id in pairs(LBP_DB[zone][subzone]) do
						LBPMainFrame.asdzone = zone
						LBPMainFrame.asdsubzone = subzone
						LBPMainFrame.asdid = id
					end
				end
			end
		end
	end
	
	if LBPMainFrame.asdid then
		LBPMainFrame:Hide()
		LBPMainFrame.test.editbutton:Hide()
		LBPMainFrame.test:Update( self, LBPMainFrame.asdzone, LBPMainFrame.asdsubzone, LBPMainFrame.asdid )
		LBPMainFrame.test:Show()
		else
		LBPMainFrame.test:Hide()
		LBPMainFrame.testtitel:Hide()
	end
	
	
end


function LBP.toggle(self, msg)
	if msg == "config" then
		LBPConfigframe:Show()
		LBPConfigframe:Build()
		else
		LBPMainframe:SetAlpha(2)
		LBPMainframe:Check()
		
		if not LBPMainframe:IsVisible() then
			LBPConfigframe:Show()
			LBPConfigframe:Build()
		end
		
	end
end


function LBP.initialize(self)													-- Beginn initialize
	
	SlashCmdList["LBP"] = function( msg )  LBP:toggle(strtrim(msg):lower()) end
	SLASH_LBP1 = "/LBP";
	SLASH_LBP1 = "/lbp";
	
	EventFrame = CreateFrame( "Frame", "LBPEventframe", UIPARENT	)
	EventFrame:SetScript("OnEvent", function(self, event, ... ) LBP:OnEvent(event, ...) end)
	EventFrame:RegisterEvent("VARIABLES_LOADED");
	EventFrame:RegisterEvent("UPDATE_MACROS");
	--EventFrame:RegisterEvent("ZONE_CHANGED");
	--EventFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA");
	--EventFrame:RegisterEvent("ZONE_CHANGED_INDOORS");
	--EventFrame:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED");
	--EventFrame:RegisterEvent("PLAYER_REGEN_ENABLED");
	
	
	EventFrame:RegisterEvent("READY_CHECK");
	--LBPObject = LBPLayoutObj()
	
	
	
	LBP:echo("initialized...")
	
end	

-- Ende initialize


-- Hilfsfunktionen zum Erstellen von Frames

function LBP.CreateFrame(self, frameType, name, parent, template, point, relativeTo, relativePoint, xOffset, yOffset, width, height)
	local frame = CreateFrame(frameType, name, parent, template);
	frame:SetPoint(point, relativeTo, relativePoint, xOffset, yOffset);
	frame:SetWidth(width);
	frame:SetHeight(height);
	
	return frame
end

function LBP.CreateFontString(self, frame, name, layer, template, point, relativeTo, relativePoint, xOffset, yOffset, width, height, justifyH, justifyV, textColorR, textColorG, textColorB, textColorA)
	local fontstring = frame:CreateFontString(nil, layer, template)
	fontstring:SetPoint(point, relativeTo, relativePoint, xOffset, yOffset)
	fontstring:SetWidth(width)
	fontstring:SetHeight(height)
	fontstring:SetJustifyH(justifyH)
	fontstring:SetJustifyV(justifyV)
	fontstring:SetTextColor( textColorR, textColorG, textColorB, textColorA );
	
	return fontstring
end


function LBP.CreateCloseButton(self, frame, name, width, point, relativeTo, relativePoint, xOffset, yOffset)
	local button = CreateFrame("BUTTON", name, frame, "UIPanelButtonTemplate")
	button:SetWidth(width)
	button:SetHeight(width)
	button:SetNormalTexture("Interface/BUTTONS/UI-Panel-MinimizeButton-Up")
	button:SetPushedTexture("Interface/BUTTONS/UI-Panel-MinimizeButton-Down")
	
	local NormalTexture = button:GetNormalTexture()
	NormalTexture:SetTexCoord(0.23, 0.77, 0.23, 0.77)
	NormalTexture:ClearAllPoints()
	NormalTexture:SetPoint("TOPLEFT", button, "TOPLEFT", 4, -4)
	NormalTexture:SetPoint("BOTTOMRIGHT", button, "BOTTOMRIGHT", -2, 2)
	
	local PushedTexture = button:GetPushedTexture()	
	PushedTexture:SetTexCoord(0.23, 0.77, 0.23, 0.77)
	PushedTexture:ClearAllPoints()
	PushedTexture:SetPoint("TOPLEFT", button, "TOPLEFT", 4, -4)
	PushedTexture:SetPoint("BOTTOMRIGHT", button, "BOTTOMRIGHT", -2, 2)
	
	
	button:SetScript("OnClick",	function(self) frame.button:GetParent():Hide()	end)
	
	if point and relativeTo and relativePoint and xOffset and yOffset then
		button:SetPoint(point, relativeTo, relativePoint, xOffset, yOffset)
	end
	
	return button
end

LBP.initialize()





